program test2;

{$mode objfpc}{$H+}

uses InterfaceBase,LCLIntf; // need Package "LCLBase"

type
   TMyClass = Class(TObject)
   procedure ChildExitEvent(AData: PtrInt; AReason: TChildExitReason; AInfo: dword); // of object;
   end;

procedure TMyClass.ChildExitEvent(AData: PtrInt; AReason: TChildExitReason; AInfo: dword);
   {my Exit-Procedure: must be a method of a Class, because it's usage in
    AddProcessEventHandler() is declared as "procedure ... of object"}
   begin
   writeln('ChildExitEvent: ', AData, ' ', AReason, ' ', AInfo);
   end;

var MyClass: TMyClass;

procedure install_ExitProc;
   const AData = 0;
   var pPEH: PProcessEventHandler; {=pointer}
       h: THandle;
   begin
   h:=system.GetProcessID;
   writeln('handle=', h);
   pPEH:=AddProcessEventHandler(h, @MyClass.ChildExitEvent, AData);
   end;

begin
writeln('hello');
MyClass:=TMyClass.Create;
MyClass.ChildExitEvent(33,cerSignal,55); // only test if this method works
install_ExitProc;
readln;
MyClass.Free;
end.

